
yarip.List = function(name)
{
	this.name = "";
	this.xpaths = {};
	this.changesMade = false;
	this.length = 0;

	this.setName = function(name)
	{
		if (name) this.name = "" + name;
	}

	this.addXPath = function(xpath)
	{
		if (!xpath) return;
		if (!this.xpaths[xpath.value]) this.length++;
		this.xpaths[xpath.value] = xpath;
		this.changesMade = true;
	}

	this.reset = function()
	{
		this.xpaths = {};
	}

	this.sortXPaths = function()
	{
		if (!this.changesMade) return; // no changes
		var xArr = [];
		for (var xValue in this.xpaths) if (this.xpaths[xValue]) xArr.push(this.xpaths[xValue]);
		xArr.sort(yarip.XPathSorter);
		var rArr = [];
		var tArr = [];
		var xpath = xArr.shift();
		while (xpath)
		{
			rArr.push(xpath);
			for (var i = 0; i < xArr.length; i++) if (!xArr[i].value.indexOf(xpath.value) == 0 || !xArr[i].value.charAt(xpath.value.length) == '/') tArr.push(xArr[i]);
			xArr = tArr;
			tArr = [];
			xpath = xArr.shift();
		}
		xArr = rArr;
		this.reset();
		for (var i = 0; i < xArr.length; i++) if (xArr[i]) this.addXPath(xArr[i]);
		this.changesMade = false;
	}

	this.generateXml = function()
	{
		var r = "";
		var tmp = "";
		for (var xValue in this.xpaths) tmp += this.xpaths[xValue].generateXml();
		if (tmp != "") r += "\t\t<" + this.name + ">\n" + tmp + "\t\t</" + this.name + ">\n";
		return r;
	}

	this.setName(name);
}
